<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml"/>
    <xsl:param name="root_table"/>
    <xsl:param name="root_field"/>

    <xsl:template match="/result">
        <xsl:apply-templates select="table[@key=$root_table]/row[@COLUMN_NAME=$root_field]">
            <xsl:with-param name="visited">|</xsl:with-param>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="row">
        <xsl:param name="visited"/>
        <xsl:choose>
            <xsl:when test="contains($visited, concat(@TABLE_NAME, '|'))">
                <xsl:element name="{@COLUMN_NAME}" namespace="{@TABLE_NAME}"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:element name="{@COLUMN_NAME}" namespace="{@TABLE_NAME}">
                    <xsl:apply-templates select="preceding-sibling::row | following-sibling::row |
                                                 /result/table[@key=current()/@REF_TABLE]/row |
                                                 /result/table/row[@REF_TABLE=current()/@TABLE_NAME and @REF_COLUMN=current()/@COLUMN_NAME]
                                                 ">
                        <xsl:with-param name="visited" select="concat($visited, @TABLE_NAME, '|')"/>
                    </xsl:apply-templates>
                </xsl:element>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>